(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common')) :
  typeof define === 'function' && define.amd ? define('stimulsoft-designer-angular', ['exports', '@angular/core', '@angular/common'], factory) :
  (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global["stimulsoft-designer-angular"] = {}, global.ng.core, global.ng.common));
})(this, (function (exports, core, common) { 'use strict';

  var StimulsoftDesignerComponent = /** @class */ (function () {
      function StimulsoftDesignerComponent() {
          /**
           * Occurs when designer loaded
           */
          this.designerLoaded = new core.EventEmitter();
          this.id = 'aDesigner' + (Math.random() * 10000000).toString();
          this.loaded = false;
      }
      StimulsoftDesignerComponent.prototype.ngOnInit = function () {
          this.addScript();
      };
      StimulsoftDesignerComponent.prototype.ngOnChanges = function (changes) {
          this.addScript();
      };
      StimulsoftDesignerComponent.prototype.addScript = function () {
          var _this = this;
          if (this.chartScripts) {
              this.head.removeChild(this.chartScripts);
          }
          this.chartScripts = document.createElement('Script');
          this.chartScripts.setAttribute('type', 'text/javascript');
          this.chartScripts.src = this.requestUrl;
          this.chartScripts.addEventListener('load', function () {
              if (!_this.loaded) {
                  try {
                      var options = new Stimulsoft.Designer.StiDesignerOptions();
                      _this.loaded = true;
                      setTimeout(function () {
                          _this.designerLoaded.next(null);
                      });
                      _this.showDesigner();
                  }
                  catch (_a) { }
              }
          });
          this.head.appendChild(this.chartScripts);
      };
      StimulsoftDesignerComponent.prototype.showDesigner = function () {
          var options = new Stimulsoft.Designer.StiDesignerOptions();
          if (this.width) {
              options.width = this.width;
          }
          if (this.height) {
              options.height = this.height;
          }
          this.designer = new Stimulsoft.Designer.StiDesigner(options, 'StiDesigner', false);
          this.designer.renderHtml(this.designerEl.nativeElement);
      };
      Object.defineProperty(StimulsoftDesignerComponent.prototype, "head", {
          get: function () {
              return document.getElementsByTagName('head')[0];
          },
          enumerable: false,
          configurable: true
      });
      return StimulsoftDesignerComponent;
  }());
  StimulsoftDesignerComponent.decorators = [
      { type: core.Component, args: [{
                  selector: 'stimulsoft-designer-angular',
                  template: "\n    <div #designer [attr.id]=\"id\">\n      <ng-content></ng-content>\n    </div>\n  "
              },] }
  ];
  StimulsoftDesignerComponent.ctorParameters = function () { return []; };
  StimulsoftDesignerComponent.propDecorators = {
      designerEl: [{ type: core.ViewChild, args: ['designer',] }],
      designerLoaded: [{ type: core.Output }],
      requestUrl: [{ type: core.Input }],
      width: [{ type: core.Input }],
      height: [{ type: core.Input }]
  };

  var StimulsoftDesignerModule = /** @class */ (function () {
      function StimulsoftDesignerModule() {
      }
      return StimulsoftDesignerModule;
  }());
  StimulsoftDesignerModule.decorators = [
      { type: core.NgModule, args: [{
                  declarations: [StimulsoftDesignerComponent],
                  imports: [
                      common.CommonModule
                  ],
                  exports: [StimulsoftDesignerComponent]
              },] }
  ];

  /*
   * Public API Surface of stimulsoft-designer-angular
   */

  /**
   * Generated bundle index. Do not edit.
   */

  exports.StimulsoftDesignerComponent = StimulsoftDesignerComponent;
  exports.StimulsoftDesignerModule = StimulsoftDesignerModule;

  Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=stimulsoft-designer-angular.umd.js.map
